#!/usr/bin/perl -w
#
# Copyright 2007 Aryeh Leib Taurog
# 
# This is free software. It is available under the same license as Perl.
# 
# This software is provided AS IS with no warranty as to its usability or
# fitness for any purpose. I disclaim all responsibility for any damage
# whatsoever resulting from the download or use of this software.

use strict;
use Getopt::Std;
use GOL::Component;
use VB::Project;
use Win32::OLE;

my %options;
getopts("fW", \%options);

my $projectFile = GOL::Component::byName($ARGV[0]) || $ARGV[0] || glob '*.vbp';

my $project = VB::Project->new($projectFile);

$project->Force() if $options{f};

$project->Compile();

my $count;
if ($count = VB::Project::compileCount())
{
    print "$count projects successfully compiled\n";
}
else
{
    print $project->Name() , " is up to date.\n";
}
