package COM::TypeLibs::Registry;
#
# Copyright 2007 Aryeh Leib Taurog
# 
# This is free software. It is available under the same license as Perl.
# 
# This software is provided AS IS with no warranty as to its usability or
# fitness for any purpose. I disclaim all responsibility for any damage
# whatsoever resulting from the download or use of this software.

use warnings;
use strict;

use Win32::OLE::Const;

# list of all registered type libraries

sub new
{
    my $class = shift;
    my $self = [];
    bless $self, $class;
    $self->Refresh();
    return $self;
}

sub TypeLibInfo
{
    my ($self, $typelib) = @_;
    my @results;
    for my $lib (@$self) 
    {
        push @results, $lib    if($lib->{name} =~ /^$typelib/i);
    }
    return @results;
}

sub Refresh
{
    my $self = shift;
    @$self = ();
    Win32::OLE::Const->EnumTypeLibs(sub {
        my ($clsid,$name,$version,$langid,$filename) = @_;
        return unless $version =~ /^([0-9A-F]+)\.([0-9A-F]+)$/i;

        push @$self, 
                { clsid   => $clsid,
                  name    => $name,
                  version => $version,
                  path    => $filename};
    });
 
}

1;
