package VB::Compiler;
#
# Copyright 2007 Aryeh Leib Taurog
# 
# This is free software. It is available under the same license as Perl.
# 
# This software is provided AS IS with no warranty as to its usability or
# fitness for any purpose. I disclaim all responsibility for any damage
# whatsoever resulting from the download or use of this software.

use strict;
use warnings;

use Carp;
use Win32::OLE;
use File::Basename;

sub new
{
    my $class = shift;
    
    my $sh = Win32::OLE->new('WScript.Shell') 
        or carp "couldn't create Shell object\n" and return undef;

    my $command = $sh->RegRead("HKEY_CLASSES_ROOT\\VisualBasic.Project\\shell\\open\\command\\")
        or carp "Visual Basic doesn't seem to be installed\n" and return undef;

    $command =~ s/.*"([^"]*vb6\.exe)".*/$1/i;
    fixSlashes($command);

    my $objRef = {  command => $command }; 

    bless $objRef, ref $class || $class;
    return $objRef;
}

sub Command
{
    return $_[0]->{command};
}

sub Make
{
    my ($self, $project) = @_;
    my $cyg = ($^O =~ /cygwin/);

    fixSlashes($project);
    my $dir = dirname $project;
    my $out = "$dir/vb6err.log";
    unlink "$out";

    return '' unless -e $project;
    $project = $cyg ? `cygpath -wal '$project'` : $project;

    #my ($name, $path) = fileparse($project);
    #$project = $cyg ? `cygpath -wal '$path'` : $path;
    chomp $project;
    #$project .= "\\$name";

    #print join(" ", $self->{command}, '/out', $args{out}, '/m', $project), "\n";
    system($self->{command}, '/out', $out, '/m', $project);

    open EFH, '<', "$out" or die "couldn't open $out: $!\n";
    my @output = <EFH>;
    close EFH or die "couldn't close $out: $!\n";

    return @output;
}

sub fixSlashes
{
    map s"\\"/"g, @_;
}

1;
