package VB::Filter;
#
# Copyright 2007 Aryeh Leib Taurog
# 
# This is free software. It is available under the same license as Perl.
# 
# This software is provided AS IS with no warranty as to its usability or
# fitness for any purpose. I disclaim all responsibility for any damage
# whatsoever resulting from the download or use of this software.

use strict;
use warnings;

require Exporter;
our @ISA = qw(Exporter);
our @EXPORT = qw(getVbLine);  # symbols to export

sub getVbLine
{
    my $fd = shift;

    my $output = '';
    my $input;

    while ($output eq '')
    {
        return undef if eof($fd);

        my $continue = 1;
        while ($continue and $input = <$fd>)
        {
            $input =~ s/\r\n$//;
            $continue = $input =~ s/ _$/ /;

            $output .= $input;
        }

        $output =~ s/\s+/ /g;
        $output =~ s/^ | $//g;
        $output =~ s/^([^"']*(?:"[^"]*"[^"']*)*)'.*/$1/;
    }

    return "$output\r\n";
}


1;
