#!/usr/bin/perl -w

use Test::More tests => 7;
use Test::Exception;
use VB::Compiler;

lives_ok{$c = VB::Compiler->new()}   'new';
ok      (defined $c,              "new returns something");
ok      ($c->isa("VB::Compiler"), "new returns right class");

like    ($c->Command(), qr/^[A-Z]:\/.*vb6.exe$/i , 'compiler path');

$output = ($c->Make("t/Simple/Simple.vbp"))[-1];
$output =~ s/\s+$//g;

is      ($output, "Build of 'Simple.exe' succeeded.", "Make");

ok      (-e "t/Simple/Simple.exe",              "Executable created");
is      (`t/Simple/Simple.exe`   , "Testing compile",   "Executable Output");

unlink "t/Simple/Simple.exe";
