#!/usr/bin/perl -w

use Test::More tests => 15;
use Test::Exception;
use VB::Project;

lives_ok{$project = VB::Project->new("t/EmptyProject/EmptyProject.vbp")}   'new';
ok      (   defined $project,                   "new returns something");
ok      (   $project->isa("VB::Project"),       "new returns right class");

dies_ok {VB::Project->new('project/that/doesn/t/exist')} "project that doesn't exist";

lives_ok{$dot  = VB::Project->new("t/EmptyProject/EmptyProject.")}   'new with dot';
lives_ok{$name = VB::Project->new("t/EmptyProject/EmptyProject")}   'new with name only';

is_deeply($project, $dot                        , "dot got same project");
is_deeply($project, $name                       , "name got same project");

ok      (defined $project->{_datafile}          , "data file");
ok      (! -e    $project->{_datafile}          , "data file doesn't exist");
ok      (!defined $project->{_data}             , "no persistent data");

SKIP: {
    skip "cygwin path checks", 3 unless $^O eq "cygwin";

    $testCwd = `cygpath -ma .`;
    chomp $testCwd;

    $testCwd .= "/t/EmptyProject/";

    is  ($project->{_path}, "$testCwd"                  , "directory path");
    is  ($project->{_vbp}, $testCwd . "EmptyProject.vbp", "project path");

    # this is not a great test, will fail on network paths, etc.
    like($testCwd       ,   qr"^[A-Z]:/"                , "path is win-style absolute");
}

$vbpFile = "t/EmptyProject/EmptyProject.vbp";
open(FH, $vbpFile) or die "Unable to open file $vbpFile: $!\n";
my @vbpText = <FH>;
close FH or die "Error closing file $vbpFile: $!\n";

is_deeply($project->{_text}  , \@vbpText         , "load project file text");

